/** \file
    \brief Used to load common 3D linear algebra classes such as matrices, vectors, and points.

The rtsLinearAlgebra.h file is used to load linear algebra objects commonly used in 3D graphics.
This includes the 3D versions of the vector, point, and matrix classes.
*/

#define RTS_PI			3.14159				/**<Defines the value of PI used in RTS algorithms*/
#define TORADIANS(a)	(a)*RTS_PI/180.0	/**<Defines a macro that converts a from degrees to radians*/
#define TODEGREES(a)	(a)*180.0/RTS_PI	/**<Defines a macro that converts a from radians to degrees*/

#include <math.h>
#include "rtsVector3d.h"
#include "rtsPoint3d.h"
#include "rtsMatrix4x4.h"